using System;
using System.ComponentModel;
using System.Xml.Serialization;

namespace EQIA.EQIDL
{
    public partial class Control : ScreenPiece
    {
        private bool myStyle_VScroll, myStyle_HScroll, myStyle_Transparent, myStyle_Border;
        private string myTooltipReference, myDrawTemplate;

        [XmlElement("Style_VScroll", IsNullable = false)]
        [Category("Style"), Description("Up/Down This control is vertically scrollable")]
        public bool Style_VScroll { get { return myStyle_VScroll; } set { myStyle_VScroll = value; } }

        [XmlElement("Style_HScroll", IsNullable = false)]
        [Category("Style"), Description("Left/Right This control is horizontally scrollable")]
        public bool Style_HScroll { get { return myStyle_HScroll; } set { myStyle_HScroll = value; } }

        [XmlElement("Style_Transparent", IsNullable = false)]
        [Category("Style"), Description("You can see through this control")]
        public bool Style_Transparent { get { return myStyle_Transparent; } set { myStyle_Transparent = value; } }

        [XmlElement("Style_Border", IsNullable = false)]
        [Category("Style"), Description("This control is surrounded by a border")]
        public bool Style_Border { get { return myStyle_Border; } set { myStyle_Border = value; } }

        [XmlElement("TooltipReference", IsNullable = false)]
        [Category("Information"), Description("Help text for this control if the user holds the cursor over this control")]
        public string TooltipReference { get { return myTooltipReference; } set { myTooltipReference = value; } }

        [XmlElement("DrawTemplate", IsNullable = false)]
        [Category("Templates"), Description("This control is surrounded by a border")]
        public string DrawTemplate { get { return myDrawTemplate; } set { myDrawTemplate = value; } }

        public Control() : this(null) { }
        public Control(EQInterface eqInterface) : base(eqInterface) { }

        protected override void SetProperties(object obj)
        {
            base.SetProperties(obj);

            Control temp_Control = obj as Control;
            if (temp_Control != null)
            {
                Style_VScroll = temp_Control.Style_VScroll;
                Style_HScroll = temp_Control.Style_HScroll;
                Style_Transparent = temp_Control.Style_Transparent;
                Style_Border = temp_Control.Style_Border;
                TooltipReference = temp_Control.TooltipReference;
                DrawTemplate = temp_Control.DrawTemplate;
            }
        }
    }
}
